ImpactsDISI (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.search, class: ImpactsDISI

Package org.apache.lucene.search

# Class ImpactsDISI

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.search.FilterDocIdSetIterator
org.apache.lucene.search.ImpactsDISI

public final class ImpactsDISI extends FilterDocIdSetIterator
`DocIdSetIterator` that skips non-competitive docs thanks to the indexed impacts. Call `setMinCompetitiveScore(float)` in order to give this iterator the ability to skip low-scoring documents.

NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.search.FilterDocIdSetIterator

  `in`

  ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

  `NO_MORE_DOCS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ImpactsDISI(DocIdSetIterator in, MaxScoreCache maxScoreCache)`
  Sole constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `advance(int target)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `MaxScoreCache`
  `getMaxScoreCache()`
  Get the `MaxScoreCache`.
  `int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
  `void`
  `setMinCompetitiveScore(float minCompetitiveScore)`
  Set the minimum competitive score.

  ### Methods inherited from class org.apache.lucene.search.FilterDocIdSetIterator

  `cost, docID`

  ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

  `all, docIDRunEnd, empty, intoBitSet, range, slowAdvance`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ImpactsDISI

    public ImpactsDISI(DocIdSetIterator in, MaxScoreCache maxScoreCache)
    Sole constructor.
    Parameters:
      `in` - the iterator, typically an ImpactsEnum
      `maxScoreCache` - the cache of maximum scores, typically computed from the same ImpactsEnum

- ## Method Details

  - ### getMaxScoreCache

    public MaxScoreCache getMaxScoreCache()
    Get the `MaxScoreCache`.

  - ### setMinCompetitiveScore

    public void setMinCompetitiveScore(float minCompetitiveScore)
    Set the minimum competitive score.
    See Also:
      - `Scorable.setMinCompetitiveScore(float)`

  - ### advance

    public int advance(int target) throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Overrides:
      `advance` in class `FilterDocIdSetIterator`
    Throws:
      `IOException`

  - ### nextDoc

    public int nextDoc() throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Overrides:
      `nextDoc` in class `FilterDocIdSetIterator`
    Throws:
      `IOException`